import os, sys

src_file_path = 'DS1000ZUpdate.GEL'

src_file_size = os.path.getsize(src_file_path)

if src_file_size != 4131715:
	sys.exit("Wrong firmware")

path = "sys"

if not os.path.exists(path):
    os.makedirs(path)

b = bytearray(open(src_file_path, 'rb').read())
h = int('0', 16)
i = h + int('280', 16)
out = b[h:i]
open('Firmware_header', 'wb').write(out)

h = int('280', 16)
i = h + int('10A814', 16)
out = b[h:i]
open('sys/SparrowAPP.out', 'wb').write(out)

h = int('10aa94', 16)
i = h + int('0C4372', 16)
out = b[h:i]
open('sys/SparrowFPGA.hex', 'wb').write(out)

h = int('1CEE06', 16)
i = h + int('046F04', 16)
out = b[h:i]
open('sys/SparrowDGFPGA.hex', 'wb').write(out)

h = int('215D0A', 16)
i = h + int('0BB818', 16)
out = b[h:i]
open('sys/logo.hex', 'wb').write(out)

h = int('2D1522', 16)
i = h + int('0206A8', 16)
out = b[h:i]
open('sys/guiResData.hex', 'wb').write(out)

h = int('2F1BCA', 16)
i = h + int('01E6A4', 16)
out = b[h:i]
open('sys/guiPicData.hex', 'wb').write(out)

h = int('31026E', 16)
i = h + int('0BB818', 16)
out = b[h:i]
open('sys/SparrowConfig.hex', 'wb').write(out)

h = int('3CBA86', 16)
i = h + int('20E8', 16)
out = b[h:i]
open('sys/SparrowWaveTable.hex', 'wb').write(out)

h = int('3CDB6E', 16)
i = h + int('022EFD', 16)
out = b[h:i]
open('sys/SparrowCalFile.hex', 'wb').write(out)

h = int('3F0A6B', 16)
i = h + int('118', 16)
out = b[h:i]
open('Firmware_footer', 'wb').write(out)


print (' * Firmware extraction done * ')

